<?php
/**
 * Created by PhpStorm.
 * User: gets
 * Date: 4/4/2019
 * Time: 1:08 PM
 */

namespace App\Http\Controllers;
use Illuminate\Http\Request;

use App\Classes\MResponse;
use GuzzleHttp\Client;

class MasheryController extends Controller
{

    public function getToken()
    {
        $mResponse = new MResponse();
        $statusCode = 200;

        try {
            $client = new Client([
                'base_uri' => 'https://api.mashery.com/v3/',
                'auth' => ['y4a5rz5ccv374qu33558f65b', 'yuZRnvKvYY'],
                'headers' => [
                    'Authorization' => 'Basic eTRhNXJ6NWNjdjM3NHF1MzM1NThmNjViOnl1WlJudkt2WVk=',
                ],
                'http_errors' => true
            ]);

            $response = $client->request('POST', 'token', [
                'form_params' => [
                    'grant_type' => 'password',
                    'username' => 'marketplace.dev',
                    'password' => 'Marketplace123',
                    'scope' => '71338066-f062-4feb-84b7-6547f0dc4e82'
                ]
            ]);

            $resBody = json_decode($response->getBody()->getContents(), true);

            if ($response->getStatusCode() != 200) {
                $statusCode = $response->getStatusCode();
                $mResponse->message = $resBody;
            } else {
                $mResponse->success = true;
                $mResponse->message = 'success';
                $mResponse->data = $resBody;
            }
            
        } catch (\Exception $e) {
            $statusCode = 500;
            $mResponse->message = $e->getMessage();
        }

        $this->token =  $resBody['access_token'];

        return response()->json($mResponse, $statusCode);
    }

    public function getUser(Request $request)
    {
        $token = $request->get('token');
        $mashUsername = $request->get('username');

        $mResponse = new MResponse();
        $statusCode = 200;

        try {
            $client = new Client([
                'base_uri' => 'https://api.mashery.com/v3/',
                'headers' => [
                    'Authorization' => 'Bearer ' . $token,
                ],
                'http_errors' => true
            ]);
            
            $response = $client->request('GET', 'rest/members?filter=username:' . $mashUsername);

            $resBody = json_decode($response->getBody()->getContents(), true);

            if ($response->getStatusCode() != 200) {
                $statusCode = $response->getStatusCode();
                $mResponse->message = $resBody;
            } else {
                $mResponse->success = true;
                $mResponse->message = 'success';
                $mResponse->data = $resBody;
            }
            
        } catch (\Exception $e) {
            $statusCode = 500;
            $mResponse->message = $e->getMessage();
        }

        return response()->json($mResponse, $statusCode);
    }

    public function createUser(Request $request)
    {
        $token = $request->get('token');
        $username = $request->get('username');
        $email = $request->get('email');
        $dname = $request->get('dname');
        $pass = $request->get('pass');

        $mResponse = new MResponse();
        $statusCode = 200;

        try {
            $client = new Client([
                'base_uri' => 'https://api.mashery.com/v3/',
                'headers' => [
                    'Authorization' => 'Bearer ' . $token,
                ],
                'http_errors' => false
            ]);

            $response = $client->request('POST', 'rest/members', [
                'json' => [
                    'username' => $username,
                    'email' => $email,
                    'displayName' => $dname,
                    'areaStatus' => 'active',
                    'externalId' => '',
                    'passwdNew' => $pass
                ]
            ]);

            $resBody = json_decode($response->getBody()->getContents(), true);

            if ($response->getStatusCode() != 200) {
                $statusCode = $response->getStatusCode();
                $mResponse->message = $resBody;
            } else {
                $mResponse->success = true;
                $mResponse->message = 'success';
                $mResponse->data = $resBody;
            }
            
        } catch (\Exception $e) {
            $statusCode = 500;
            $mResponse->message = $e->getMessage();
        }

        return response()->json($mResponse, $statusCode);
    }
}
